package org.molplexdrug.Action;

import java.io.ByteArrayInputStream;
import java.io.IOException;
import java.io.InputStream;

import javax.enterprise.context.SessionScoped;
import javax.inject.Inject;
import javax.inject.Named;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;



import org.jboss.seam.framework.EntityHome;
import org.molplexdrug.DAO.PerlService;
import org.molplexdrug.DAO.Search;
import org.openscience.cdk.Molecule;
import org.openscience.cdk.exception.CDKException;
import org.openscience.cdk.interfaces.IMolecule;
import org.openscience.cdk.io.MDLV2000Reader;
import org.openscience.cdk.smiles.SmilesGenerator;
import org.openscience.cdk.tools.manipulator.AtomContainerManipulator;
import org.switchyard.component.bean.Reference;
import org.switchyard.component.bean.Service;
import org.w3c.dom.Document;
import org.xml.sax.SAXException;

//@Named("search")
@Named("search")
@SessionScoped
@Service(Search.class)

public class SearchBean implements Search{
	
	private String strMol;
	
	private static final String soapRequest2 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
            + "    <soap:Body>"
            + "        <perl:addNumbers xmlns:perl=\"urn:cdl_wsfunctions\">"
            + "            <arg1>10</arg1>"
            + "            <arg2>50</arg2>"
            + "            </perl:addNumbers>"
            + "    </soap:Body>"
            + "</soap:Envelope>";
    
    private static final String soapRequest3 = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
            + "    <soap:Body>"
            + "        <perl:addRequest xmlns:perl=\"urn:cdl_wsfunctions\">"
            + "            <arg1>C1CCCCCCC1</arg1>"
            + "            <arg2>2</arg2>"
            + "            </perl:addRequest>"
  
            + "    </soap:Body>"
            + "</soap:Envelope>";

    private String _result = "";

    @Inject @Reference("PerlService")
    private PerlService _perlService;
   
    public String getResult() {
        return _result;
    }

    public void setResult(String result) {
        _result = result;
    }

    
   public void call(String soapRequest) {
        System.out.println("Calling WS implemented in Perl!");
        _result = _perlService.call(soapRequest);
        System.out.println("Result = " + _result);
    }

 
	public String subStructure(){
		String message="";
		String smiles=getSmilesFromMolecule();
		String soapRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
	            + "    <soap:Body>"
	            + "        <perl:addRequest xmlns:perl=\"urn:cdl_wsfunctions\">"
	            + "            <arg1>"+smiles+"</arg1>"
	            + "            <arg2>1</arg2>"
	            + "            </perl:addRequest>"
	  
	            + "    </soap:Body>"
	            + "</soap:Envelope>";
		_result = _perlService.call(soapRequest);
		System.out.println("Result = " + _result);
		
		DocumentBuilder newDocumentBuilder;
		try {
			newDocumentBuilder = DocumentBuilderFactory.newInstance().newDocumentBuilder();
			Document parse = newDocumentBuilder.parse(new ByteArrayInputStream(_result.getBytes()));
			System.out.println(parse.getFirstChild().getTextContent());
		} catch (ParserConfigurationException e) {
			e.printStackTrace();
		} catch (SAXException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		return "/chemvector/SearchMolecule.xhtml";
	}

	

	public String exactSearch() {
		// TODO Auto-generated method stub
		String message="";
		String smiles=getSmilesFromMolecule();
		String soapRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
	            + "    <soap:Body>"
	            + "        <perl:addRequest xmlns:perl=\"urn:cdl_wsfunctions\">"
	            + "            <arg1>"+smiles+"</arg1>"
	            + "            <arg2>2</arg2>"
	            + "            </perl:addRequest>"
	  
	            + "    </soap:Body>"
	            + "</soap:Envelope>";
		_result = _perlService.call(soapRequest);
		System.out.println("Result = " + _result);
		return "/chemvector/SearchMolecule.xhtml";
	}

	public String pharmacore() {
		// TODO Auto-generated method stub
		String message="";
		String smiles=getSmilesFromMolecule();
		String soapRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
	            + "    <soap:Body>"
	            + "        <perl:addRequest xmlns:perl=\"urn:cdl_wsfunctions\">"
	            + "            <arg1>"+smiles+"</arg1>"
	            + "            <arg2>3</arg2>"
	            + "            </perl:addRequest>"
	  
	            + "    </soap:Body>"
	            + "</soap:Envelope>";
		_result = _perlService.call(soapRequest);
		System.out.println("Result = " + _result);
		return "/chemvector/SearchMolecule.xhtml";
	}

	public String shapeSearch() {
		// TODO Auto-generated method stub
		String message="";
		String smiles=getSmilesFromMolecule();
		String soapRequest = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
	            + "<soap:Envelope xmlns:soap=\"http://www.w3.org/2003/05/soap-envelope\">"
	            + "    <soap:Body>"
	            + "        <perl:addRequest xmlns:perl=\"urn:cdl_wsfunctions\">"
	            + "            <arg1>"+smiles+"</arg1>"
	            + "            <arg2>4</arg2>"
	            + "            </perl:addRequest>"
	  
	            + "    </soap:Body>"
	            + "</soap:Envelope>";
		_result = _perlService.call(soapRequest);
		System.out.println("Result = " + _result);
		
		return "/chemvector/SearchMolecule.xhtml";
	}
	public String getSmilesFromMolecule(){
		InputStream is = new ByteArrayInputStream(strMol.getBytes());
		MDLV2000Reader molReader = new MDLV2000Reader(is);
		SmilesGenerator sg = new SmilesGenerator();
		IMolecule im = null;
		try {
			im = molReader.read(new Molecule());
		} catch (CDKException e) {
			e.printStackTrace();
		}
		im = (IMolecule) AtomContainerManipulator.removeHydrogens(im);
		String smiles = sg.createSMILES(im);
		System.out.println("----Generated Smiles--for the mol file-----"+smiles);
		return smiles;
	}

	public String getStrMol() {
		return strMol;
	}

	public void setStrMol(String strMol) {
		this.strMol = strMol;
	}

	public void addNumber() {
		_result = _perlService.addNumber(soapRequest2);
        System.out.println("Result = " + _result);
 
		
	}

	public void addRequest() {
		// TODO Auto-generated method stub
		_result = _perlService.addRequest(soapRequest3);
        System.out.println("Result = " + _result);
		
	}

	
	
}
